# coding: utf-8

"""
    Talos

    FastAPI Best Architecture

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from talos_aclient.models.retrieve_metadata import RetrieveMetadata
from typing import Optional, Set
from typing_extensions import Self

class RetrieveSegment(BaseModel):
    """
    RetrieveSegment
    """ # noqa: E501
    page_content: Optional[StrictStr] = None
    metadata: Optional[RetrieveMetadata] = None
    collection_name: Optional[StrictStr] = None
    match_nodes: Optional[List[StrictStr]] = None
    __properties: ClassVar[List[str]] = ["page_content", "metadata", "collection_name", "match_nodes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RetrieveSegment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of metadata
        if self.metadata:
            _dict['metadata'] = self.metadata.to_dict()
        # set to None if page_content (nullable) is None
        # and model_fields_set contains the field
        if self.page_content is None and "page_content" in self.model_fields_set:
            _dict['page_content'] = None

        # set to None if metadata (nullable) is None
        # and model_fields_set contains the field
        if self.metadata is None and "metadata" in self.model_fields_set:
            _dict['metadata'] = None

        # set to None if collection_name (nullable) is None
        # and model_fields_set contains the field
        if self.collection_name is None and "collection_name" in self.model_fields_set:
            _dict['collection_name'] = None

        # set to None if match_nodes (nullable) is None
        # and model_fields_set contains the field
        if self.match_nodes is None and "match_nodes" in self.model_fields_set:
            _dict['match_nodes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RetrieveSegment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "page_content": obj.get("page_content"),
            "metadata": RetrieveMetadata.from_dict(obj["metadata"]) if obj.get("metadata") is not None else None,
            "collection_name": obj.get("collection_name"),
            "match_nodes": obj.get("match_nodes")
        })
        return _obj


